// find msgIdentity Element and give Parents a name ...
var Obj_MsgIdentity = document.getElementById("msgIdentity");

var parent_hbox = Obj_MsgIdentity.parentNode;
parent_hbox.setAttribute("id", "msgIdentityHbox");

var new_vbox = document.createElement("vbox");
new_vbox.setAttribute("id", "msgIdentityVbox");
new_vbox.setAttribute("flex", "1");

parent_hbox.replaceChild(new_vbox, Obj_MsgIdentity);

new_vbox.appendChild(Obj_MsgIdentity);

// replace FillIdentityListPopup with our own version to prevent showing
// Virtual Identity Accounts in different (parallel) MailCompose Dialogs
dump("## V_Identity: replace FillIdentityListPopup\n");
FillIdentityListPopup = function (popup) {VIdentity_FillIdentityListPopup(popup);}


function open_homepage()
{
var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
messenger.launchExternalURL("http://absorb.it/hacked/thunderbird/v_identity.html");
}

function dumpServerData(server)
{
    dump("Server:biffMinutes " + server.biffMinutes + "\n");
    dump("Server:biffState " + server.biffState + "\n");
    dump("Server:canCreateFoldersOnServer " + server.canCreateFoldersOnServer + "\n");
    dump("Server:canDelete " + server.canDelete + "\n");
    dump("Server:canFileMessagesOnServer " + server.canFileMessagesOnServer + "\n");
    dump("Server:defaultCopiesAndFoldersPrefsToServer " + server.defaultCopiesAndFoldersPrefsToServer + "\n");
    dump("Server:deferGetNewMail " + server.deferGetNewMail + "\n");
    dump("Server:deferredToAccount " + server.deferredToAccount + "\n");
    dump("Server:deleteByAgeFromServer " + server.deleteByAgeFromServer + "\n");
    dump("Server:deleteMailLeftOnServer " + server.deleteMailLeftOnServer + "\n");
    dump("Server:displayStartupPage " + server.displayStartupPage + "\n");
    dump("Server:doBiff " + server.doBiff + "\n");
    dump("Server:dotFix " + server.dotFix + "\n");
    dump("Server:downloadOnBiff " + server.downloadOnBiff + "\n");
    dump("Server:emptyTrashOnExit " + server.emptyTrashOnExit + "\n");
    dump("Server:headersOnly " + server.headersOnly + "\n");
    dump("Server:hostName " + server.hostName + "\n");
    dump("Server:isSecure " + server.isSecure + "\n");
    dump("Server:key " + server.key + "\n");
    dump("Server:leaveMessagesOnServer " + server.leaveMessagesOnServer + "\n");
    dump("Server:limitOfflineMessageSize " + server.limitOfflineMessageSize + "\n");
    dump("Server:localPath " + server.localPath + "\n");
    dump("Server:localPath.leafName " + server.localPath.leafName + "\n");
    dump("Server:localPath.nativePath " + server.localPath.nativePath + "\n");
    dump("Server:localPath.persistentDescriptorString " + server.localPath.persistentDescriptorString + "\n");
    dump("Server:localPath.unicodePath " + server.localPath.unicodePath + "\n");
    dump("Server:localPath.unixStyleFilePath " + server.localPath.unixStyleFilePath + "\n");
    dump("Server:localPath.URLString " + server.localPath.URLString + "\n");
    dump("Server:loginAtStartUp " + server.loginAtStartUp + "\n");
    dump("Server:maxMessageSize " + server.maxMessageSize + "\n");
    dump("Server:numDaysToLeaveOnServer " + server.numDaysToLeaveOnServer + "\n");
    dump("Server:offlineSupportLevel " + server.offlineSupportLevel + "\n");
    dump("Server:password " + server.password + "\n");
    dump("Server:performingBiff " + server.performingBiff + "\n");
    dump("Server:pop3CapabilityFlags " + server.pop3CapabilityFlags + "\n");
    dump("Server:port " + server.port + "\n");
    dump("Server:prettyName " + server.prettyName + "\n");
    dump("Server:redirectorType " + server.redirectorType + "\n");
    dump("Server:rootFolder " + server.rootFolder + "\n");
}

function dumpAccountData(account)
{
    dump("#####################################################################\n");
    dumpServerData(account.incomingServer);
    //~ dumpServerData(account.localFoldersServer);
    
    var identity = account.defaultIdentity;
    dump("Identity:composeHtml " + identity.composeHtml + "\n");
      dump("Identity:directoryServer " + identity.directoryServer + "\n");
      dump("Identity:doFcc " + identity.doFcc + "\n");
      dump("Identity:draftFolder " + identity.draftFolder + "\n");
      dump("Identity:draftsFolderPickerMode " + identity.draftsFolderPickerMode + "\n");
      dump("Identity:email " + identity.email + "\n");
      dump("Identity:fccFolder " + identity.fccFolder + "\n");
      dump("Identity:fccFolderPickerMode " + identity.fccFolderPickerMode + "\n");
      dump("Identity:overrideGlobalPref " + identity.overrideGlobalPref + "\n");
      dump("Identity:showSaveMsgDlg " + identity.showSaveMsgDlg + "\n");
      dump("Identity:stationeryFolder " + identity.stationeryFolder + "\n");
      dump("Identity:tmplFolderPickerMode " + identity.tmplFolderPickerMode + "\n");
    dump("#####################################################################\n");
}

function VIdentity_FillIdentityListPopup(popup)
{
  var accounts = queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);
  accounts.sort(compareAccountSortOrder);

  for (var i in accounts) {
    var server = accounts[i].incomingServer;
    
    // changed next line to ignore (other) VirtualIdentity Accounts
    if (!server || server.hostName == "VirtualIdentity")
       continue;
    //~ dumpAccountData(accounts[i]);
    var identites = queryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);
    for (var j in identites) {
      var identity = identites[j];
      var item = document.createElement("menuitem");
      item.className = "identity-popup-item";
      item.setAttribute("label", identity.identityName);
      item.setAttribute("value", identity.key);
      item.setAttribute("accountkey", accounts[i].key);
      item.setAttribute("accountname", " - " + server.prettyName);
      
      popup.appendChild(item);
    }
  }
}


var active = null; // stores if the extension is active, functions are replaced etc.
function expand()
{
     var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
     if (Obj_SendMsgHeaders.getAttribute("hidden") == "true") {
	if (active == null) {
		// FIRST CALL: initialize the hole Extension
		if (replaceGenericFuntions() == "true") {
			initNewFields();
			active = 1;
		}
		else {
		  Obj_expandButton.setAttribute("hidden", "true");
		  dump("WARNING:Cannot hook message sending -- you will not be able to fake Identitys\n");
		}
		}
 	  if (active == 1) { showExtension(); }
	}
     else {
	hideExtension();
	updateDropdownMenu();
	}
}


function showExtension()
{	
	var Obj_expandButton = document.getElementById("expandButton");
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	var Obj_MsgIdentity = document.getElementById("msgIdentity");
	Obj_SendMsgHeaders.setAttribute("hidden", "false");
	Obj_MsgIdentity.setAttribute("hidden", "true");
	Obj_MsgIdentity.setAttribute("style", "background-color:transparent;")
	Obj_expandButton.setAttribute("class","expandHeaderViewButton");
}

function hideExtension()
{
	var Obj_expandButton = document.getElementById("expandButton");
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	var Obj_MsgIdentity = document.getElementById("msgIdentity");
	Obj_SendMsgHeaders.setAttribute("hidden", "true");
	Obj_MsgIdentity.setAttribute("hidden", "false");
	Obj_MsgIdentity.setAttribute("style", "")
	Obj_expandButton.setAttribute("class","collapsedHeaderViewButton");
}

var vident_origGenericSendMessage = null;
var vident_origComposeUnload = null;
var vident_origMsgComposeCloseWindow = null;
var vident_origDoCommandClose = null;
var vident_origLoadIdentity = null;
function replaceGenericFuntions()
{
	// some code borrowed from enigmail
	if (typeof(GenericSendMessage)=="function" && typeof(ComposeUnload)=="function"
			&& typeof(DoCommandClose)=="function" && typeof(LoadIdentity)=="function") {
	  // replace GenericSendMessage with our own version
	  if (!vident_origGenericSendMessage) {
		dump("## V_Identity: replace GenericSendMessage\n");
		vident_origGenericSendMessage = GenericSendMessage;
		GenericSendMessage = function (msgType) {VIdentity_GenericSendMessage(msgType);}
	  }
	  // replace ComposeUnload with our own version
	  //~ if (!vident_origComposeUnload) {
		//~ dump("## V_Identity: replace ComposeUnload\n");
		//~ vident_origComposeUnload = ComposeUnload;
		//~ ComposeUnload = function () {VIdentity_ComposeUnload();}
	  //~ }
	  // replace MsgComposeCloseWindow with our own version
	  if (!vident_origMsgComposeCloseWindow) {
		dump("## V_Identity: replace MsgComposeCloseWindow\n");
		vident_origMsgComposeCloseWindow = MsgComposeCloseWindow;
		MsgComposeCloseWindow = function (recycleIt) {VIdentity_MsgComposeCloseWindow(recycleIt);}
	  }
	  // replace DoCommandClose with our own version
	  //~ if (!vident_origDoCommandClose) {
		//~ dump("## V_Identity: replace DoCommandClose\n");
		//~ vident_origDoCommandClose = DoCommandClose;
		//~ DoCommandClose = function () {VIdentity_DoCommandClose();}
	  //~ }
	  // replace LoadIdentity with our own version
	  if (!vident_origLoadIdentity) {
		dump("## V_Identity: replace LoadIdentity\n");
		vident_origLoadIdentity = LoadIdentity;
		LoadIdentity = function (startup) {VIdentity_LoadIdentity(startup);}
	  }
	  return "true"}
	else {
	  dump("## V_Identity ERROR: could not replace your SendMessage ComposeUnload DoCommandClose and/or LoadIdentity Function, aborting\n"); 
	  return "false";
	  }
}

var VIdent_Account = null;
function createVIdentity_Account()
{
  if (VIdent_Account) return; // if the Account is still created, then leave all like it is
  var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
  
  VIdent_Account = AccManager.createAccount();
  var VIdent_Identity = AccManager.createIdentity();
  
  VIdent_Account.addIdentity(VIdent_Identity);
  
  var Number = getNewAccountNumber();
  
  var server = AccManager.createIncomingServer("user"+Number,"VirtualIdentity","pop3");
  server.prettyName = document.getElementById("prettyName-Prefix").getAttribute("label") + Number;
  VIdent_Account.incomingServer = server;
  
  // remove the folder created with this account - it should never be used to store mails
  VIdent_Account.incomingServer.rootFolder.Delete();
  
  dump("## V_Identity: New Account created "+server.prettyName+"\n");
}


function initNewFields()
{
	var identityElement_fullName = document.getElementById("msg_fullName");
	identityElement_fullName.value = gCurrentIdentity.fullName;
	var identityElement_useremail = document.getElementById("msg_useremail");
	identityElement_useremail.value = gCurrentIdentity.email;
	loadSMTP_server_list();
}

// this was the main way to get rid of the account again, but on windows it looks like
// it isnt called everytime after closing the MessageComposeWindow ....
function VIdentity_ComposeUnload()
{ dump("## V_Identity: ComposeUnload\n"); vident_origComposeUnload(); VIdentity_Cleanup(); }
// ... so the Account is now still removed if somebody presses the Close-Button of the window.
function VIdentity_DoCommandClose()
{	dump("## V_Identity: DoCommandClose\n");
	if (gPromptService) { dump("#####PromptService found\n"); }
	VIdentity_Cleanup(); return DoCommandClose(); }

function VIdentity_MsgComposeCloseWindow(recycleIt)
{
  dump("## V_Identity: MsgComposeCloseWindow\n");
  VIdentity_Cleanup();
  MsgComposeCloseWindow(recycleIt);
}


// if VIdentity Extension is closed after it was used, then remove the Virtual Account if a
// different one is choosed
function VIdentity_LoadIdentity(startup)
{
	dump("## V_Identity: Identity changed\n");
	var identityList = document.getElementById("msgIdentity");
	if (identityList.value != "")
		{ VIdentity_Cleanup(); LoadIdentity(startup);}
}

// Clean all the things I had changed (expecpt the FillIdentityListPopup)
function VIdentity_Cleanup()
{
  dump("## V_Identity: Cleanup\n");
  VIdentity_Cleanup_AccountAndListener();
  
  // restore functions
  if (vident_origGenericSendMessage) { GenericSendMessage = vident_origGenericSendMessage; vident_origGenericSendMessage = null; }
  if (vident_origComposeUnload) { ComposeUnload = vident_origComposeUnload; vident_origComposeUnload = null; }
  if (vident_origMsgComposeCloseWindow) { MsgComposeCloseWindow = vident_origMsgComposeCloseWindow; vident_origMsgComposeCloseWindow = null; }
  if (vident_origDoCommandClose) { DoCommandClose = vident_origDoCommandClose; vident_origDoCommandClose = null; }
  if (vident_origLoadIdentity) { LoadIdentity = vident_origLoadIdentity; vident_origLoadIdentity = null; }
  
  // remove Menuitem
  if (MenuItem) {
    var identityListPopup = document.getElementById("msgIdentityPopup");
    identityListPopup.removeChild(MenuItem);
    MenuItem = null;
  }
  if (FormerIdentity) FormerIdentity = null;
  
  active = null;
  hideExtension();
}

function VIdentity_Cleanup_AccountAndListener()
{
  // remove temporary Account
  if (VIdent_Account) {
    var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
    dump("## V_Identity: Account " + VIdent_Account.incomingServer.prettyName + " removed\n")
    VIdent_Account.incomingServer.rootFolder.Delete();
    AccManager.removeAccount(VIdent_Account);
    VIdent_Account = null;
  }

  // remove Listener  
  if (StateListenerRegistered) {
	gMsgCompose.UnregisterStateListener(VIdentComposeStateListener);
	StateListenerRegistered = null;
  }
}

// This is another Way to get rid of the Account, if the mail is sended thisone should work ...
var VIdentComposeStateListener = {
  NotifyComposeFieldsReady: function() {
    dump("###### NotifyComposeFieldsReady\n");
  },

  ComposeProcessDone: function(aResult) {
    dump("## V_Identity: StateListener reports ComposeProcessDone\n");
    VIdentity_Cleanup(); setDefaultMenuEntry();
  },

  SaveInFolderDone: function(folderURI) {
    dump("###### SaveInFolderDone\n");
  }
};


var StateListenerRegistered = null;
function VIdentity_GenericSendMessage( msgType )
{
	dump("## V_Identity: VIdentity_GenericSendMessage\n");
	// dont allow user to fake identity if Message is not sended NOW!!!!
	if (msgType != nsIMsgCompDeliverMode.Now) {
		var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
		var server = AccManager.defaultAccount.incomingServer.prettyName
		var name = AccManager.defaultAccount.defaultIdentity.fullName
		var email = AccManager.defaultAccount.defaultIdentity.email

		//Get the bundled string file.
		var stringBundle = document.getElementById("vIdentBundle");
		
		if (confirm(stringBundle.getString("vident.sendLater.warning") +
			stringBundle.getString("vident.sendLater.prefix") +
			name + " " + email + " [" + server + "]" + stringBundle.getString("vident.sendLater.postfix")))
			{
				VIdentity_Cleanup();
				setDefaultMenuEntry();
				GenericSendMessage( msgType );
			}
		else { return; }
		}
	else
        {
		createVIdentity_Account();
		storeIdentity();
		setMsgIdentityMenu();
		gMsgCompose.RegisterStateListener(VIdentComposeStateListener);
		StateListenerRegistered = 1;
		vident_origGenericSendMessage( msgType );
		if (window.cancelSendMessage) {
			VIdentity_Cleanup_AccountAndListener();
			dump("## V_Identity: SendMessage cancelled\n");
		}
	}
}


function setDefaultMenuEntry()
{
	var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
	// set MenuEntry to default one
	var identityList = document.getElementById("msgIdentity");
	identityList.value = AccManager.defaultAccount.defaultIdentity.key;
	identityList.setAttribute("label", AccManager.defaultAccount.defaultIdentity.identityName);
	identityList.setAttribute('accountname', " - " +  AccManager.defaultAccount.incomingServer.prettyName);
	identityList.setAttribute("accountkey", AccManager.defaultAccount.key);
}

function setMsgIdentityMenu()
{
  if (!MenuItem) { updateDropdownMenu(); };
  
  //~ identityListPopup.removeChild(MenuItem);
  MenuItem.setAttribute("label", VIdent_Account.defaultIdentity.identityName);
  MenuItem.setAttribute("accountname", " - " +  VIdent_Account.incomingServer.prettyName);
  MenuItem.setAttribute("accountkey", VIdent_Account.key);
 
  // set the  account name on the menu list value.
  var identityList = document.getElementById("msgIdentity");
  identityList.setAttribute("label", document.getElementById("menuListItem-Head").getAttribute("label") + VIdent_Account.defaultIdentity.identityName);
  identityList.setAttribute('accountname', " - " +  VIdent_Account.incomingServer.prettyName);
  identityList.setAttribute("accountkey", VIdent_Account.key);
  identityList.value = VIdent_Account.defaultIdentity.key;
}


var MenuItem = null;
var FormerIdentity = null;
function updateDropdownMenu()
{
  var curIdentity = getCurrentIdentity();
  if (curIdentity) FormerIdentity = curIdentity; // We have to store the former Identity to use the settings of this later
  var identityListPopup = document.getElementById("msgIdentityPopup");
  var identityList = document.getElementById("msgIdentity");
  var identityElement_fullName = document.getElementById("msg_fullName");
  var identityElement_useremail = document.getElementById("msg_useremail");

  if (!MenuItem) {
	// add entry to identityList
	MenuItem = document.createElement("menuitem");
	MenuItem.className = "identity-popup-item";
	identityListPopup.appendChild(MenuItem);
  }
  
  // set the account name in the choosen menu item
  MenuItem.setAttribute("label", identityElement_fullName.value + " <" + identityElement_useremail.value + ">");
  MenuItem.setAttribute("accountname", " - " + document.getElementById("prettyName-Prefix").getAttribute("label"));
  MenuItem.setAttribute("accountkey", "");
 
  // set the account name on the menu list value.
  identityList.setAttribute("label", identityElement_fullName.value + " <" + identityElement_useremail.value + ">");
  identityList.setAttribute('accountname', " - " + document.getElementById("prettyName-Prefix").getAttribute("label"));
  identityList.setAttribute("accountkey", "");
  identityList.value = "";
}

function getCurrentIdentity()
{
    // fill in Identity combobox
    var identityList = document.getElementById("msgIdentity");

    var identityKey = identityList.value;

    var identity = gAccountManager.getIdentity(identityKey);

    return identity;
}


function storeIdentity()
{
  var identityElement_fullName = document.getElementById("msg_fullName");
  var identityElement_useremail = document.getElementById("msg_useremail");
  var serverMenu = document.getElementById("smtp_server_list");
		
  VIdent_Account.defaultIdentity.setUnicharAttribute("fullName", identityElement_fullName.value);
  VIdent_Account.defaultIdentity.setCharAttribute("useremail", identityElement_useremail.value);
  
  if (serverMenu.selectedItem)
   VIdent_Account.defaultIdentity.smtpServerKey = serverMenu.selectedItem.getAttribute('key');
  else dump("## V_Identity: ############ SMTP-Server unselected, please report this bug.\n");
  dump("## V_Identity: Stored VirtualIdentity (name " + VIdent_Account.defaultIdentity.fullName + " email " +
	VIdent_Account.defaultIdentity.email + " smtp " + VIdent_Account.defaultIdentity.smtpServerKey +")\n");
	
  var VIdent_Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  
  var doFcc; try { doFcc = VIdent_Prefs.getBoolPref("virtual_identity.doFcc"); } catch (ex) {doFcc = true;}
  var fccFolder; try { fccFolder = VIdent_Prefs.getCharPref("virtual_identity.fcc_folder"); } catch (ex) { fccFolder = "";}
  var fccFolderPickerMode; try { fccFolderPickerMode = VIdent_Prefs.getCharPref("virtual_identity.fcc_folder_picker_mode"); } 
		catch (ex) {fccFolderPickerMode = "3";}
  

  if (doFcc) {
	//~ dump ("## V_Identity: preparing Fcc\n");
	switch (fccFolderPickerMode) 
	{
	    case "2"  :
	    	dump ("## V_Identity: preparing Fcc --- use Settings of Default Account\n");
		var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
		VIdent_Account.defaultIdentity.doFcc = AccManager.defaultAccount.defaultIdentity.doFcc;
		VIdent_Account.defaultIdentity.fccFolder = AccManager.defaultAccount.defaultIdentity.fccFolder;
		VIdent_Account.defaultIdentity.fccFolderPickerMode = AccManager.defaultAccount.defaultIdentity.fccFolderPickerMode;
		break;
	    case "3"  :
		dump ("## V_Identity: preparing Fcc --- use Settings of Modified Account\n");
		if (!FormerIdentity)  FormerIdentity = getCurrentIdentity();
		if (FormerIdentity) {
			VIdent_Account.defaultIdentity.doFcc = FormerIdentity.doFcc;
			VIdent_Account.defaultIdentity.fccFolder = FormerIdentity.fccFolder;
			VIdent_Account.defaultIdentity.fccFolderPickerMode = FormerIdentity.fccFolderPickerMode;
		}
		break;
	    default  :
		dump ("## V_Identity: preparing Fcc --- use Virtual Identity Settings\n");
		VIdent_Account.defaultIdentity.doFcc = doFcc;
		VIdent_Account.defaultIdentity.fccFolder = fccFolder;
		VIdent_Account.defaultIdentity.fccFolderPickerMode = fccFolderPickerMode;
		break;
	}
  }
  else {
	dump ("## V_Identity: dont performing Fcc\n");
	VIdent_Account.defaultIdentity.doFcc = false;
	}
  dump("## V_Identity: Stored (doFcc " + VIdent_Account.defaultIdentity.doFcc + " fccFolder " +
	VIdent_Account.defaultIdentity.fccFolder + " fccFolderPickerMode " +
	VIdent_Account.defaultIdentity.fccFolderPickerMode + ")\n");
}

//~ Checks if there is stil another VIdentity Account and creates a new one
function getNewAccountNumber()
{
  var accounts = queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);
  
  var FreeVIdentityNumber = 0
  var i = 0
  while (i < accounts.length) {
    var server = accounts[i].incomingServer;
    if (server && server.hostName == "VirtualIdentity" 
	&& server.prettyName == document.getElementById("prettyName-Prefix").getAttribute("label") + FreeVIdentityNumber) {
		FreeVIdentityNumber++; i = 0;}
    else { i++; }
    }
  return FreeVIdentityNumber;
}

// some code borrowed from showsmtpuser extension
function loadSMTP_server_list()
{
	var smtpService
	if (!smtpService)
        smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
	var serverList = document.getElementById("smtp_server_list_popup");
	while (serverList.hasChildNodes())
		serverList.removeChild(serverList.lastChild);
	var serverMenu = document.getElementById("smtp_server_list");
    
	if (getCurrentIdentity().smtpServerKey) 
		var idserver = smtpService.getServerByKey(getCurrentIdentity().smtpServerKey);
	else	var idserver = smtpService.defaultServer;

	var defaultServer = smtpService.defaultServer;
	var servers = smtpService.smtpServers
    
	var serverCount = servers.Count();

	for (var i=0 ; i<serverCount; i++) {
		var server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
		if (!server.redirectorType) 
		{
		  var listitem = createSmtpListItemx(server);
		  serverList.appendChild(listitem);
		  // set choosen default server 
		  if (idserver == server) serverMenu.selectedItem = listitem;
		}
	}
	serverMenu.label = getNewHostnamex(idserver);
	
}

function createSmtpListItemx(server) {
    var listitem = document.createElement("menuitem");

    var hostname = getNewHostnamex(server);
    
    listitem.setAttribute("label", hostname);
    listitem.setAttribute("key", server.key);
    // give it some unique id
    listitem.id = "smtpServer." + server.key;

    return listitem;
}


function getNewHostnamex(server)
{
    var showAlias = true;
    var showUsername = true;
    var hideUsername = true;

    
    // reuse Preferences from ssun
    try { showAlias = prefService.getBoolPref("ssun.showalias"); } catch (ex) {}
    try { showUsername = prefService.getBoolPref("ssun.showusername"); } catch (ex) {}
    try { hideUsername = prefService.getBoolPref("ssun.hideusername"); } catch (ex) {}

    var hostname = server.hostname;
    var port = "";

    if (server.port)
      port = ":" + server.port;

    // SSUN: Get server alias
    var alias = "";
    if (showAlias) {
        try { alias = prefService.getCharPref("ssun." + server.key + ".alias"); } catch (ex) {}
        if (alias) {
            hostname = alias;
        } else {
            hostname += port;
        }
    } else {
        hostname += port;
    }

    // SSUN: Add username
    if (showUsername && (!showAlias || (showAlias && (!alias || !hideUsername))) && server.authMethod && server.username)
      hostname += " (" + server.username + ")";

    return hostname
}
